﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Stimulsoft.Report;
using Merkur.Data;
using Stimulsoft.Report.Components;
using System.Drawing.Printing;
using Stimulsoft.Base.Drawing;
using System.Drawing;
using Stimulsoft.Report.Engine;

namespace Merkur.WPFReports
{
    public class ReportHelper
    {
        private ClaimListHeadDto mHead;
        private List<ClaimListDto> mClaimList;

        public ReportHelper()
        {

        }

        public ReportHelper(ClaimListHeadDto head, List<ClaimListDto> list)
        {
            mHead = head;
            mClaimList = list;
        }

        public StiReport GetReportById(int id)
        {
            StiReport report = new StiReport();
            SetDefaultReport(ref report);

            switch (id)
            {
                case 1001:
                    report.ReportName = "Forderungsaufstellung";
                    report.ReportAlias = "ClaimList";

                    new ClaimList(mHead, mClaimList).Fill(ref report);
                    break;
                default:
                    break;
            }

            return report;
        }

        private void SetDefaultReport(ref StiReport report)
        {
            report.Pages.Clear();

            report.NeedsCompiling = false;
            report.EngineVersion = StiEngineVersion.EngineV2;
            report.PreviewSettings = 268435455;
            report.ReferencedAssemblies = new string[]
                                                {
                                                    "Stimulsoft.Base.Dll",
                                                    "Stimulsoft.Controls.Dll",
                                                    "Stimulsoft.Report.Dll",
                                                    "System.Dll",
                                                    "System.Data.Dll",
                                                    "System.Drawing.Dll",
                                                    "System.Windows.Forms.Dll",
                                                    "System.Xml.Dll"
                                                };
            report.ReportCreated = DateTime.Now;
            report.ReportGuid = new Guid().ToString();
            report.ReportUnit = StiReportUnitType.Centimeters;
            report.ReportVersion = "2016.3.0";
            report.ScriptLanguage = StiReportLanguageType.CSharp;
        }
    }
}
